"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _oors = require("oors");

var _File = _interopRequireDefault(require("./services/File"));

var _File2 = _interopRequireDefault(require("./repositories/File"));

var _router = _interopRequireDefault(require("./router"));

var _upload = _interopRequireDefault(require("./middlewares/upload"));

var _upload2 = _interopRequireDefault(require("./schemas/upload"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class FileStorage extends _oors.Module {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "name", 'oors.fileStorage');

    _defineProperty(this, "config", {
      oors: {
        mongodb: {
          repositories: {
            autoload: false
          }
        },
        rad: {
          autoload: {
            services: false
          }
        }
      }
    });
  }

  initialize({
    uploadDir
  }) {
    const uploadMiddleware = (0, _upload.default)({
      dest: uploadDir
    });
    this.router = (0, _router.default)({
      uploadMiddleware
    });
    this.export({
      uploadMiddleware
    });
  }

  async setup() {
    const [{
      addRepository
    }] = await this.dependencies(['oors.mongodb']);
    const fileRepository = addRepository('File', new _File2.default());
    const fileService = new _File.default({
      uploadDir: this.getConfig('uploadDir'),
      FileRepository: fileRepository,
      validateUpload: this.manager.compileSchema(_upload2.default)
    });
    fileRepository.File = fileService;
    this.export({
      File: fileService,
      FileRepository: fileRepository
    });
  }

}

_defineProperty(FileStorage, "schema", {
  type: 'object',
  properties: {
    uploadDir: {
      type: 'string'
    }
  },
  required: ['uploadDir']
});

var _default = FileStorage;
exports.default = _default;