"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _mongodb = require("mongodb");

var _oorsMongodb = require("oors-mongodb");

var _file = _interopRequireDefault(require("../schemas/file"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class FileRepository extends _oorsMongodb.Repository {
  async deleteMany(params) {
    const {
      query
    } = params;
    const files = await this.findMany({
      query,
      fields: ['extension']
    });
    const result = await _oorsMongodb.Repository.prototype.deleteMany.call(this, params);

    if (this.File && Array.isArray(files) && files.length) {
      await this.File.removeFiles(files);
    }

    return result;
  }

  async deleteOne(params) {
    let file;

    if (params instanceof _mongodb.ObjectID) {
      file = await this.findById(params);
    } else {
      file = await this.findOne({
        query: params.query
      });
    }

    const result = await _oorsMongodb.Repository.prototype.deleteOne.call(this, params);

    if (this.File && file) {
      await this.File.removeFile(file);
    }

    return result;
  }

}

_defineProperty(FileRepository, "schema", _file.default);

_defineProperty(FileRepository, "collectionName", 'oorsFile');

var _default = FileRepository;
exports.default = _default;